Lua_ExpeditionBoxItem = class("Lua_ExpeditionBoxItem", Lua_DisplayObject);
function Lua_ExpeditionBoxItem:ctor(p)
	self:superCall("ctor", p, "ExpeditionBoxItem_skin");
end

function Lua_ExpeditionBoxItem:buildShowItem()
	self:superCall("buildShowItem");
	self.effectIcon = UICreate.createUIAtlasImage(self.content, nil, nil, 0, 0, 0, 0);
	self.effectIcon.siblingIndex = 1;
	self.boxIcon:addClickFuntion(self, self.onBoxIconClick);
end

function Lua_ExpeditionBoxItem:dispose()
	self.data = nil;
	self:superCall("dispose");
end

function Lua_ExpeditionBoxItem:setData(data)
	self.data = data;

	self.state = DataCenter.expeditionData:getStarState(data.id);
	local str = string.sub(data.box_icon, 1, string.len(data.box_icon) - 1);
	if self.state == 2 then
		self.boxIcon:setAltas("common_altas_4", str.."p");
	else
		self.boxIcon:setAltas("common_altas_4", str.."n");
	end
	if self.state == 1 then
		self.effectIcon:setEnable(true);
		self.effectIcon:setAltas("common_altas_4", str.."p_t");
	else
		self.effectIcon:setEnable(false);
	end

	self.starNum.text = data.star_num;
	self.starNum:resetSize();
	self.starIcon:setLocation(self.starNum.posX + self.starNum.width / 2 + 10, -22, 0);
end

function Lua_ExpeditionBoxItem:onBoxIconClick(go)
	if self.data == nil then
		return;
	end

	if self.state == 1 then
		Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sBoxReceive(self.data.id);
	else
		Lua_WindowUtil.openWin("Lua_ExpeditionBoxDetailsWindow", Lua_WinParam.ACTION_OPEN);
	end
end