-- 边境远征
checkRequire("Lua_ExpeditionSingleItem");
checkRequire("Lua_ExpeditionBoxItem");
Lua_ExpeditionWindow = class("Lua_ExpeditionWindow", Lua_Window);
function Lua_ExpeditionWindow:ctor()
	self:superCall("ctor");

	self.layer = MainWinDefine.NORMAL_WINDOW_LAYER;
	self.windowName = "Lua_ExpeditionWindow";
	self.skinName = "ExpeditionWindow_skin";
	self.isFullSizeWin = true;
    self.bgWidth = 720;
    self.bgHight = 2245;
	self:addPreLoadRes("/images/expedition/ui_bjyz_bj_01.jpg", Lua_LoadFileType.IMG);
	self:addPreLoadRes("/images/expedition/ui_bjyz_bj_02.jpg", Lua_LoadFileType.IMG);
end

function Lua_ExpeditionWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.subRectH = self.bgHight - self.height;
	self.cellHeight = 0;
	self.subMinPos = -self.subRectH / 2;
	self.subMaxPox = -self.subMinPos;
	self.spaceWidth = 210;

    self.scrollContainer = UICreate.createScrollContainer(self.content, 0, 0, self.width, self.height);
    self.scrollContainer.bCreateContent = true;
    self.scrollContainer.horizontal = false;
    self.scrollContainer.vertical = true;
    self.scrollContainer.movementTypeValue = 2;
    self.scrollContainer.elasticity = 0.3;
    self.scrollContainer.inertia = true;
    self.scrollContainer:setScrollSize(0, self.subRectH);
    self.scrollContainer:setScrollPivot(4);
    self.scrollContainer:addMousDownFuntion(self, self.onMouseDownFun);
    self.scrollContainer:addMouseUpFuntion(self, self.onMouseUpFun);
    self.scrollContainer.siblingIndex = 0;

    self.sub = self.scrollContainer.scrollContent;
    self.subRect = self.scrollContainer.scrollRect;
    self.showImg1 = UICreate.createImage(self.sub, "/images/expedition/ui_bjyz_bj_01.jpg", 0, self.bgHight / 2, self.bgWidth, 1024);
    self.showImg1.pivotValue = 1;
    self.showImg2 = UICreate.createImage(self.sub, "/images/expedition/ui_bjyz_bj_02.jpg", 0, self.bgHight / 2 - 1024, self.bgWidth, 1023);
    self.showImg2.pivotValue = 1;
    self.showImg3 = UICreate.createImage(self.sub, "/images/expedition/ui_bjyz_bj_03.jpg", 0, self.bgHight / 2 - 1024 - 1023, self.bgWidth, 197);
    self.showImg3.pivotValue = 1;
    self.modelImg = UICreate.createImage(self.sub, nil, 0, 650, 0, 0);

	self.btnHelp:addClickFuntion(self, self.onBtnHelpClick);
	self.revivalIcon:addClickFuntion(self, self.onRevivalIconClick);
	-- self.heroIcon:addClickFuntion(self, self.onHeroIconClick);
	self.buffIcon:addClickFuntion(self, self.onBuffIconClick);
	self.shopIcon:addClickFuntion(self, self.onShopIconClick);

	self:addLuaEvent("UPDATE_EXPEDITION_INFO", self, self.updateShowInfo);
	self:addLuaEvent("EXPEDITION_STAR_REWARD", self, self.showBox);
	Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sExpeditionInfo();
	Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sHaveHeroList();

	if DataCenter.expeditionData.buff_state == 1 then
		Lua_WindowUtil.openWin("Lua_ExpeditionBuffChooseWindow", Lua_WinParam.ACTION_OPEN);
	end
end

function Lua_ExpeditionWindow:dispose()
	self:endTimer();
	self:removeMoveTimer();
	if self.showList ~= nil then
		self.showList:dispose();
		self.showList:clear();
		self.showList = nil;
	end
	if self.hideList ~= nil then
		self.hideList:dispose();
		self.hideList:clear();
		self.hideList = nil;
	end
	if self.boxArr ~= nil then
		self.boxArr:dispose();
		self.boxArr:clear();
		self.boxArr = nil;
	end
    self.sub = nil;
    self.subRect = nil;
    if self.scrollContainer ~= nil then
        self.scrollContainer:dispose();
        self.scrollContainer = nil;
    end
	self:superCall("dispose");
end

function Lua_ExpeditionWindow:onScreenResize()
	self:superCall("onScreenResize");
	self.subRectH = self.bgHight - self.height;
	self.cellHeight = self.subRectH / self.cellsCount;
	self.subMinPos = -(self.bgHight - self.height) / 2;
	self.subMaxPox = -self.subMinPos;

	self.scrollContainer:SetDimensions(self.width, self.height);
	self.scrollContainer:setScrollSize(0, self.subRectH);
end

function Lua_ExpeditionWindow:onMouseDownFun()
	self:removeMoveTimer();
	self.startMouseX = CommonUtil.mousePositionX;
	self.startMouseY = CommonUtil.mousePositionY;
	self.startClickTime = getTime();
	self.pressItem = self:checkClick();
end

function Lua_ExpeditionWindow:onMouseUpFun()
	if self.pressItem ~= nil then
		local dx = CommonUtil.mousePositionX - self.startMouseX;
		local dy = CommonUtil.mousePositionY - self.startMouseY;
		if getTime() - self.startClickTime <= 0.3 and Mathf.Abs(dx) + Mathf.Abs(dy) < 4 then
			self.pressItem:onPressClick()
		end
	end
	self.pressItem = nil;
end

function Lua_ExpeditionWindow:updateShowInfo()
	local data = DataCenter.expeditionData;
	-- print(data.cur_stage, data.cur_location, data.cur_state)

	if data.cur_layer == 3 then
		self.startY = 970;
		self.modelImg:setUrl("/images/expedition/ui_bjyz_icon_bg_03.png");
	else
		self.startY = 890;
		self.modelImg:setUrl("/images/expedition/ui_bjyz_icon_bg_02.png");
	end

	local str = LanUtil.formateStr(330001, convert_arab_to_chinese(data.cur_layer));
	if data.cur_difficulty == 1 then
		str = spliceStr(str, LanUtil.formateStr(10048, LanUtil.getValue(330004)));
	elseif data.cur_difficulty == 2 then
		str = spliceStr(str, LanUtil.formateStr(10048, LanUtil.getValue(330005)));
	end
	self.layerText.text = str;
	self.reward_1.text = data.expedition_amount;
	self.reward_2.text = data.coin_amount;

	local sub_times = DataCenter.expeditionUtil:getConstConfig("sub_times", 1, 0) * 60;
	self.left_sec = data.left_sec - sub_times;
	if self.left_sec > 0 then
		self.isEndTimer = false;
	else
		self.left_sec = data.left_sec;
		self.isEndTimer = true; -- 结算期
	end
	self:startTimer();
	self:onTimer();

	self:createMap(data);
	self:showBox();
end

function Lua_ExpeditionWindow:startTimer()
	if self.bTiming ~= true then
		self.bTiming = false;
		self:addTimer("Lua_ExpeditionWindow", 1, self, self.onTimer);
	end
end

function Lua_ExpeditionWindow:endTimer()
	if self.bTiming == true then
		self.bTiming = false;
		self:removeTimer(self, self.onTimer);
	end
end

function Lua_ExpeditionWindow:onTimer()
	self.left_sec = self.left_sec - 1;
	if self.left_sec > 0 then
		if self.isEndTimer then
			self.timeText:setLangValue(330003);
		else
			self.timeText.text = LanUtil.formateStr(330002, Lua_TimeTransform.transSeconds6(self.left_sec));
		end
	else
		self:endTimer();
		self.timeText.text = "";
		Lua_ProxyManager.getProxy("Lua_ExpeditionProxy"):sExpeditionInfo(); -- 校正处理
	end
end

function Lua_ExpeditionWindow:checkClick()
	if self.showList ~= nil then
		local winPos = LuaUtil.getTouchPosInverseObj(self.sub);
		local len = self.showList:getSize();
		for i = 1, len do
			if self.showList[i].isActive and self.showList[i]:checkInBound(winPos.x, winPos.y) then
				return self.showList[i];
			end
		end
	end
    return nil;
end

function Lua_ExpeditionWindow:createMap(data)
	self:returntItem();

	local arr = DataCenter.expeditionUtil:getMapArr(data.cur_layer, data.cur_difficulty);
	self.cellsCount = arr:getSize();
	self.cellHeight = self.subRectH / self.cellsCount;
	local index;
	local mapNum;
	local startX;
	local item;
	for i = 1, self.cellsCount do
		if arr[i].stage == data.cur_stage then
			index = i;
		end

		mapNum = arr[i].map;
		startX = -(mapNum - 1) * self.spaceWidth / 2;
		for j = 1, mapNum do
			item = self:createItem();
			item:setRectSize(182, 100);
			if i == 1 then
				item:setRectSize(265, 170);
				item:setLocation(startX, 800, 0);
			elseif i == 2 then
				if data.cur_layer == 3 then
					item:setLocation(startX, 740, 0);
				else
					item:setLocation(startX, 655, 0);
				end
			elseif i == 3 then
				if data.cur_layer == 3 then
					item:setLocation(startX, 640, 0);
				else
					item:setLocation(startX, 560, 0);
				end
			else
				item:setLocation(startX, self.startY - (i - 1) * 170, 0);
			end
			item:setData(arr[i], j);
			startX = startX + self.spaceWidth;
		end
	end
	index = index == nil and 1 or index;
	if index < Mathf.Ceil(self.cellsCount / 2) then
		self:moveToIndex(index - 1);
	else
		self:moveToIndex(index + 1);
	end
end

function Lua_ExpeditionWindow:createItem()
	if self.showList == nil then
		self.showList = Array();
	end
	if self.hideList == nil then
		self.hideList = Array();
	end
	local len = self.hideList:getSize();
	local item = nil;
	if len > 0 then
		item = self.hideList:remove();
		item:setEnable(true);
	end

	if item == nil then
		item = Lua_ExpeditionSingleItem.new(self.sub);
	end
	self.showList:add(item);
	return item;
end

function Lua_ExpeditionWindow:returntItem()
	if self.showList == nil or self.hideList == nil then
		return;
	end

	local len = self.showList:getSize();
	local item;
	while len > 0 do
		item = self.showList:remove(len);
		item:setEnable(false);
		self.hideList:add(item)
		len = len - 1;
	end
end

function Lua_ExpeditionWindow:moveToIndex(idx)
    self.targetPos = self.subMinPos;
    for i = 1, idx - 1 do
        self.targetPos = self.targetPos + self.cellHeight;
    end

    if self.targetPos > self.subMaxPox then
        self.targetPos = self.subMaxPox;
    elseif self.targetPos < self.subMinPos then
        self.targetPos = self.subMinPos;
    end

    self:removeMoveTimer();
    self:startMoveTimer();
end

function Lua_ExpeditionWindow:startMoveTimer()
    if self.bMoveTimer ~= true then
        self.bMoveTimer = true;
        Lua_CommonUtil.addTimer("Lua_ExpeditionWindow_Move", 0.01, self, self.onMoveTimer);
    end
end

function Lua_ExpeditionWindow:removeMoveTimer()
    if self.bMoveTimer == true then
        self.bMoveTimer = false;
        Lua_CommonUtil.removeTimer(self, self.onMoveTimer);
    end
end

function Lua_ExpeditionWindow:onMoveTimer()
    local pos = self.subRect.anchoredPosition.y;
    if Mathf.Abs(pos - self.targetPos) < 2 then
        self:removeMoveTimer();
        self.scrollContainer:setScrollPosition(0, self.targetPos, 0);
    else
        pos = (self.targetPos - pos) * 0.1 + pos;
        self.scrollContainer:setScrollPosition(0, pos, 0);
    end
end

function Lua_ExpeditionWindow:showBox()
	local config = DataCenter.expeditionUtil:getStarInfo();
	table.sort(config, function(a, b) return a.id < b.id end);
	local dataLen = config == nil and 0 or #config;
	local starNum = DataCenter.expeditionData.star_num;
	local maxNum = config[dataLen].star_num;
	self.reward_3.text = "（"..starNum.."/"..maxNum.."）";

	local value = 0;
	local index = 1;
	if starNum >= maxNum then
		value = maxNum;
	else
		local oneMax = maxNum / dataLen; -- 每一段的最大值
		for i = 1, dataLen do
			if config[i].star_num >= starNum then
				index = i;
				break;
			end
		end
		value = value + oneMax * (index - 1); -- 当前所在段之前所有值

		local num;
		if index <= 1 then
			num = oneMax / config[index].star_num;
			value = value + starNum * num;
		else
			num = oneMax / (config[index].star_num - config[index - 1].star_num);
			value = value + (starNum - config[index - 1].star_num) * num;
		end
	end
	self.boxBar:setMaxValue(maxNum * 100);
	self.boxBar:setValue(value * 100);

	if self.boxArr == nil then
		self.boxArr = Array();
	end
	local len = self.boxArr:getSize();
	maxNum = len > dataLen and len or dataLen;
	local item;
	for i = 1, maxNum do
		item = self.boxArr[i];
		if i > dataLen then
			if item ~= nil then
				item:setEnable(false);
			end
		else
			if item == nil then
				item = Lua_ExpeditionBoxItem.new(self.content);
				self.boxArr:add(item);
			else
				item:setEnable(true);
			end
			item:setLocation(-315, i / dataLen * 659 - 334, 0);
			item:setData(config[i]);
		end
	end
end

function Lua_ExpeditionWindow:onBtnHelpClick(go)
	local tipsData = { posX = 210, posY = -165, des = LanUtil.getValue(330000) };
	Lua_WindowUtil.openWin("Lua_InstructionTipsWindow", Lua_WinParam.ACTION_OPEN, tipsData);
end

function Lua_ExpeditionWindow:onRevivalIconClick(go)
	Lua_WindowUtil.openWin("Lua_ExpeditionHeroReviveWindow", Lua_WinParam.ACTION_OPEN);
end

-- function Lua_ExpeditionWindow:onHeroIconClick(go)
-- 	Lua_WindowUtil.openWin("Lua_ExpeditionHeroWindow", Lua_WinParam.ACTION_OPEN);
-- end

function Lua_ExpeditionWindow:onBuffIconClick(go)
	Lua_WindowUtil.openWin("Lua_ExpeditionBuffWindow", Lua_WinParam.ACTION_OPEN);
end

function Lua_ExpeditionWindow:onShopIconClick(go)
	DataCenter.funcPathUtil:gotoFunction(1043);
end